<template>
  <div>
    <h1>Fibonnacii</h1>
    <div>
      <label for="nr">K = </label>
      <input id="nr" type="number" v-model="input" min="1" max="999"/>
      <button type="button" @click="calculate">Calculate</button>
    </div>
    <div>
      Fibonacci({{ input }}) = {{ result }}
    </div>
    <div>
      <h2>History (
        <button @click="getHistory">refresh</button>
        )
      </h2>
      <ul>
        <li v-for="(el, i) in history" :key="i">{{ el.k }}</li>
      </ul>
    </div>
  </div>
</template>

<script lang="ts">
import {setup, Vue} from 'vue-class-component';
import {onMounted} from "vue";

const API_URL = '//localhost:3000/fib/'

export default class Fibonnacci extends Vue {
  input = 1;
  result = 0;
  history = [5, 3];

  fib = setup(() => {
    onMounted(() => {
      this.getHistory()
    })

    return {};
  })

  calculateFibo = (result: number, counter: number): number => {
    if (counter === 0) {
      return 0;
    } else if (counter === 1) {
      return 1;
    } else {
      return this.calculateFibo(result, counter - 2)
          + this.calculateFibo(result, counter - 1);
    }
  }

  getHistory = async () => {
    const res = await fetch(API_URL + 'history')
    this.history = await res.json();
  }

  calculate = async () => {
    const response = await fetch(API_URL + this.input);

    const result = await response.json()

    this.result = result[0].result

    await this.getHistory()
  }


}
</script>

<style scoped>
h3 {
  margin: 40px 0 0;
}

ul {
  list-style-type: none;
  padding: 0;
}

li {
  margin: 0 10px;
}

a {
  color: #42b983;
}
</style>
